''*****************************************************************************
''
''	Platformer tutorial 101
''
''	Chapter 03-C
''  Acceleration in Delta Time
''
''	Relminator (Richard Eric M. Lope)
''	http://rel.phatcode.net
''
''
''  I'm using EASY GL2D for rendering.
'' 	So try to read these tutorials for Easy GL2D..
'' 	http://back2basic.phatcode.net/?Issue_%232:Basic_2D_Rendering_in_OpenGL_using_Easy_GL2D%3A_Part_1
'' 	http://back2basic.phatcode.net/?Issue_%232:Basic_2D_Rendering_in_OpenGL_using_Easy_GL2D%3A_Part_2

''*****************************************************************************
#include once "fbgfx.bi"
#include once "FBGL2d7.bi" 
#include once "FBGL2d7.bas" 

const as integer SCREEN_WIDTH = 640
const as integer SCREEN_HEIGHT = 480


const as integer FALSE = 0
const as integer TRUE = not FALSE
const as single PI = atn(1) * 4

const as single ACCELERATION = 10.0

Type Ball
	
	declare constructor()
	declare sub Update( byval dt as single )
	declare sub Draw( byval Colour as integer )
	
	as single X
	as single Y
	as single Speed
	as single Dx
	as single Dy
	as single DirX
	as single DirY
	
End Type

constructor Ball()

	x = rnd * SCREEN_WIDTH
	y = rnd * SCREEN_HEIGHT
	dim as single a = (rnd * 360) * PI / 180  
	Speed = 0  ''80 + rnd * 180
	DirX = cos(a)
	DirY = sin(a) 

End Constructor

sub Ball.Update( byval dt as single )
	
	Speed += ACCELERATION * dt			'' accelerate by dt amount * frames
	if Speed > 180 then Speed = 180		'' limit speed or we go waaay fast
	Dx = DirX * Speed  	'' Calculate direction
	Dy = DirY * Speed 	'' No need to do dt here
	X += Dx * dt	'' scale our movement by how much time
	Y += Dy	* dt	'' has elapsed since last update
	
	'' bounce around if we hit a wall
	if( X < 0 ) then Dirx = -Dirx
	if( X > SCREEN_WIDTH ) then Dirx = -Dirx
	if( Y < 0 ) then Diry = -Diry
	if( Y > SCREEN_HEIGHT ) then Diry = -Diry
	  
End Sub

sub Ball.Draw( byval Colour as integer )
	
	GL2D.Circle( x, y, 20, Colour )

End Sub


''*****************************************************************************
'' Our main sub
''*****************************************************************************
sub main()

	
	GL2D.ScreenInit( SCREEN_WIDTH, SCREEN_HEIGHT )   ''Set up GL screen
	
	const as double FIXED_TIME_STEP = 1/60.0
	
	
	dim as Ball Balls( 30 )
	
	dim as integer Frame = 0
	dim as single FPS = 0
	dim as single dt
	dim as single LastTime = Timer
	dim as single CurrentTime = Timer
	dim as single SecondsElapsed = 0
	dim as single StartTime = Timer
	
	
	do
		
		'' Calculate deltatime
		CurrentTime = Timer
		dt = CurrentTime - LastTime
		LastTime = CurrentTime
		
		'' Fix frame-skipping by limiting the value of our dt
		'' to the maximum of FIXED_TIME_STEP
		if( dt > FIXED_TIME_STEP ) then dt = FIXED_TIME_STEP   '' This is the fix
		
		
		SecondsElapsed += dt
				
		
		Frame += 1
			
		for i as integer = 0 to ubound(balls)
			Balls(i).Update( dt )
		next
		
		GL2D.ClearScreen()
			
		GL2D.Begin2D()
	
			for i as integer = 0 to ubound(balls)
				Balls(i).Draw( GL2D_RGBA(255,255,255,255) )
			Next
		
			GL2D.PrintScale(0, 0, 1, "Acceleration in Deltatime")
			
		GL2D.End2D()
		
		'sleep 1,1
		flip
		
	Loop until multikey(FB.SC_ESCAPE)


	GL2D.ShutDown()
	
End Sub

''*****************************************************************************
''*****************************************************************************


main()


end


